﻿using Syncfusion.ListView.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SfListViewSample
{
   public class Behavior : Behavior<ContentPage>
    {

        #region Fields

        List<ListViewItemInfo> items;
        int i = 0;
        SfListView ListView; Button button;

        #endregion Fields

        protected override void OnAttachedTo(ContentPage page)
        {
            ListView = page.FindByName<SfListView>("listView");
            button = page.FindByName<Button>("button");
            button.Clicked += Button_Clicked;
            base.OnAttachedTo(page);
        }

        private async void Button_Clicked(object sender, EventArgs e)
        {
            i++;
            await Task.Delay(1000);
            var linearLayout = ListView.LayoutManager as LinearLayout;
            items = linearLayout.GetType().GetField("items", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance).GetValue(linearLayout) as List<ListViewItemInfo>;
            var runtimemethod = ListView.DragDropController.GetType().GetRuntimeMethods().FirstOrDefault(methodname => methodname.Name == "HandleTouchInteractions");
            runtimemethod.Invoke(ListView.DragDropController, new object[] { items[i], GestureStatus.Started, Xamarin.Forms.Point.Zero, new Point(0, 0) });
            await Task.Delay(500);
            runtimemethod.Invoke(ListView.DragDropController, new object[] { items[i], GestureStatus.Running, new Point(100, 100), new Point(0, 0) });
            var runtimefields = ListView.DragDropController.GetType().GetRuntimeFields().FirstOrDefault(fieldname => fieldname.Name == "endItemIndex");
            runtimefields.SetValue(ListView.DragDropController, 2);
            await Task.Delay(500);
            runtimemethod.Invoke(ListView.DragDropController, new object[] { items[i], GestureStatus.Completed, new Point(240, 240), new Point(0, 0) });
            await Task.Delay(500);

        }
    }
}
