﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace SfListViewSample
{
    public class ContactsViewModel : INotifyPropertyChanged
    {
        #region Fields

        private ObservableCollection<Contacts> contactitems;
        private Random r = new Random();

        public Image GroupHeaderImage
        {
            get { return this.image; }
            set
            {
                this.image = value;
                this.RaisedOnPropertyChanged("GroupHeaderImage");
            }
        }

        #endregion Fields

        #region Properties

        public ObservableCollection<Contacts> ContactItems
        {
            get { return contactitems; }
            set
            {
                contactitems = value;
                RaisedOnPropertyChanged("ContactItems");
            }
        }
        public Image ExpandIcon { get; set; }


        #endregion Properties

        #region Constructor

        public ContactsViewModel()
        {
            contactitems = new ObservableCollection<Contacts>();
            LoadData(12);
        }

        #endregion Constructor

        #region Methods

        public void LoadData(int count)
        {
            for (int i = 0; i < count; i++)
            {
                var contact = new Contacts(CustomerNames[i], r.Next(720, 799).ToString() + " - " + r.Next(3010, 3999).ToString());
                contact.ContactColor = Color.FromRgb(r.Next(40, 255), r.Next(40, 255), r.Next(40, 255));
                contact.ContactImage = ImageSource.FromResource("SfListViewSample.Images.Image" + r.Next(0, 28) + ".png");
                ContactItems.Add(contact);
            }
        }

        #endregion Methods

        #region ItemsSource

        //string[] CustomerNames = new string[] {
        //    "Alex",
        //    "Aiden",
        //    "Irene",
        //    "Katie",
        //    "Michael",
        //    "Aaron",
        //    "Ralph",
        //    "Torrey",
        //    "William",
        //    "Bill",
        //    "Daniel",
        //    "Frank",
        //    "Brenda",
        //    "Danielle",
        //    "Fiona",
        //    "Howard",
        //    "Jack",
        //    "Larry",
        //    "Holly",
        //    "Jennifer",
        //    "Liz",
        //    "Pete",
        //    "Steve",
        //    "Vince",
        //    "Zeke",
        //    "Jackson"    ,
        //    "Mason  "    ,
        //    "Liam   "    ,
        //    "Jacob  "    ,
        //    "Jayden "    ,
        //    "Ethan  "    ,
        //    "Noah   "    ,
        //    "Lucas  "    ,
        //    "Logan  "    ,
        //    "Caleb  "    ,
        //    "Caden  "    ,
        //    "Jack   "    ,
        //    "Ryan   "    ,
        //    "Connor "    ,
        //    "Michael"    ,
        //    "Elijah "    ,
        //    "Brayden"    ,
        //    "Benjamin"   ,
        //    "Nicholas"   ,
        //    "Alexander"  ,
        //    "William"    ,
        //    "Matthew"    ,
        //    "James  "    ,
        //    "Landon "    ,
        //    "Nathan "    ,
        //    "Dylan  "    ,
        //    "Evan   "    ,
        //    "Luke   "    ,
        //    "Andrew "    ,
        //    "Gabriel"    ,
        //    "Gavin  "    ,
        //    "Joshua "    ,
        //    "Owen   "    ,
        //    "Daniel "    ,
        //    "Carter "    ,
        //    "Tyler  "    ,
        //    "Cameron"    ,
        //    "Christian"  ,
        //    "Wyatt  "    ,
        //    "Henry  "    ,
        //    "Eli    "    ,
        //    "Joseph "    ,
        //    "Max    "    ,
        //    "Isaac  "    ,
        //    "Samuel "    ,
        //    "Anthony"    ,
        //    "Grayson"    ,
        //    "Zachary"    ,
        //    "David  "    ,
        //    "Christopher",
        //    "John   "    ,
        //    "Isaiah "    ,
        //    "Levi   "    ,
        //    "Jonathan"   ,
        //    "Oliver "    ,
        //    "Chase  "    ,
        //    "Cooper "    ,
        //    "Tristan"    ,
        //    "Colton "    ,
        //    "Austin "    ,
        //    "Colin  "    ,
        //    "Charlie"    ,
        //    "Dominic"    ,
        //    "Parker "    ,
        //    "Hunter "    ,
        //    "Thomas "    ,
        //    "Ian    "    ,
        //    "Jordan "    ,
        //    "Cole   "    ,
        //    "Julian "    ,
        //    "Aaron  "    ,
        //    "Carson "    ,
        //    "Miles  "    ,
        //    "Blake  "    ,
        //    "Brody  "    ,
        //    "Adam   "    ,
        //    "Sebastian"  ,
        //    "Adrian "    ,
        //    "Nolan  "    ,
        //    "Sean   "    ,
        //    "Riley  "    ,
        //    "Bentley"    ,
        //    "Xavier "    ,
        //    "Hayden "    ,
        //    "Jeremiah"   ,
        //    "Jason  "    ,
        //    "Jake   "    ,
        //    "Asher  "    ,
        //    "Micah  "    ,
        //    "Jace   "    ,
        //    "Brandon"    ,
        //    "Josiah "    ,
        //    "Hudson "    ,
        //    "Nathaniel"  ,
        //    "Bryson "    ,
        //    "Ryder  "    ,
        //    "Justin "    ,
        //    "Bryce  "    ,
        //};
        //
        private string[] CustomerNames = new string[] {
            "Alex",
            "Irene",
             "Katie",
            "Michael",
            "Ralph",
            "Torrey",
            "William",
            "Bill",
            "Daniel",
            "Holly",
            "Jennifer",
            "Liz",
            "Pete",
            "Vince",
            "Zeke",

        };

        private Image image;

        #endregion ItemsSource

        #region INotifyPropertyChanged Interface

        public event PropertyChangedEventHandler PropertyChanged;

        public void RaisedOnPropertyChanged(string _PropertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(_PropertyName));
            }
        }

        #endregion INotifyPropertyChanged Interface
    }
}